<?php
function book_vocab_views_tables() {
  $tables['book_vocab'] = array(
    'name' => 'book_vocab',
      'fields' => array(
        'primary_terms' => array(
          'name' => t('Vocabulary per-Book: Terms for primary vocabulary'),
          'help' => t('Displays terms from the primary vocabulary of a book.'),
          'notafield' => TRUE,
          'handler' => 'views_handler_field_primary_vocab_terms',
          'option' => array(
            '#type' => 'select',
            '#options' => array(
              'link' => 'As links',
              'nolink' => 'Without links'
            ),
          ),
        ),
      ),
  );
  return $tables;
}

function views_handler_field_primary_vocab_terms($fieldinfo, $fielddata, $value, $data) {

  $vid = db_result(db_query("SELECT bv.vid FROM {book_vocab} bv INNER JOIN {book_bridge} bb ON bb.bid=bv.bid  WHERE bb.nid = %d and bv.is_primary = 1 ", $data->nid));
  $terms = taxonomy_node_get_terms_by_vocabulary($data->nid, $vid);

  if ($fielddata['options'] == 'nolink') {
    foreach ($terms as $term) {
      $links[] = check_plain($term->name);
    }
    $links = !empty($links) ? implode(' | ', $links) : '';
  }
  else {
    $node = new stdClass();
    $node->taxonomy = $terms;
    $links = theme('links', taxonomy_link('taxonomy terms', $node));
  }
  
  return $links;
}